## Welcome to the ungleich-game, a geek game engine!

ungleich-game is supposed to be an easy-to-use, easy-to-play and
easy-to-extend game framework for geeks.

It features registration, challenges with dependencies and an easy
point system.

The project name is ungleich-game, as it has its roots at ungleich -
the project name might change later.

## How to play (in general)

* Select a game server
* Register
* List challenges - have fun!

### How to play (for instance on Nico's notebook)

1. Register: send a POST request with your username

```
curl -d user=nico http://nico.ungleich.cloud:5002/register
```

2. Get challenges

```
curl http://nico.ungleich.cloud:5002/challenge
```

3. Get a challenge description

```
curl http://nico.ungleich.cloud:5002/challenge/registernet
```

4. Solve a challenge

```
curl -d user=nico -d 2a0a:e5c0:101::/64 http://nico.ungleich.cloud:5002/challenge/RegisterNet
```

5. Get high score

```
curl http://nico.ungleich.cloud:5002/highscore
```


## Overview - Game flow

* Users register at a game server
* Users play by getting challenges from the game server
* Users can see their or all high scores on the main page

## Overview - Development Flow

[not yet fully implemented]

The idea is that there are challenges and each challenge offers:

* A description
* Some dependencies (on something another challenge can provide)
* A score ("how difficult it is")

### How to add challenges

* Create challenges-<YOURNAME>.py and add challenges in there
* Do some magic so all challenges are imported by server

### How to run your own game server

Run
```
python server.py
```


## Overview - Security

None at the moment.


## Tech stack

The base for building games is:

* Python3 - The programmming language
* Flask   - web frontend
* etcd    - storing data, games, etcd.

## Things to solve

* Enhance the Challenge class - maybe make it easier for challenges to abort
* Enhance the Challenge class - abstract away writing information?
* Implement dependencies / providers for challenges
* Add an easy to use CLI (Steven might like click)
* Write nice code to easily retrieve points per user
* Sort high score
* Maybe store all user information in one JSON object?
